diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index fe37e65af0..963464c9ad 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -280,6 +280,7 @@ eqsel_internal(PG_FUNCTION_ARGS, bool negate)
 		selec = var_eq_non_const(&vardata, operator, collation, other,
 								 varonleft, negate);
 
+	pfree(other);
 	ReleaseVariableStats(vardata);
 
 	return selec;
@@ -1960,15 +1961,15 @@ scalararraysel(PlannerInfo *root,
 		{
 			List	   *args;
 			Selectivity s2;
-
-			args = list_make2(leftop,
-							  makeConst(nominal_element_type,
-										-1,
-										nominal_element_collation,
-										elmlen,
-										elem_values[i],
-										elem_nulls[i],
-										elmbyval));
+			Const *c = makeConst(nominal_element_type,
+								-1,
+								nominal_element_collation,
+								elmlen,
+								elem_values[i],
+								elem_nulls[i],
+								elmbyval);
+
+			args = list_make2(leftop, c);
 			if (is_join_clause)
 				s2 = DatumGetFloat8(FunctionCall5Coll(&oprselproc,
 													  clause->inputcollid,
@@ -1984,7 +1985,8 @@ scalararraysel(PlannerInfo *root,
 													  ObjectIdGetDatum(operator),
 													  PointerGetDatum(args),
 													  Int32GetDatum(varRelid)));
-
+			list_free(args);
+			pfree(c);
 			if (useOr)
 			{
 				s1 = s1 + s2 - s1 * s2;
@@ -2051,6 +2053,7 @@ scalararraysel(PlannerInfo *root,
 													  ObjectIdGetDatum(operator),
 													  PointerGetDatum(args),
 													  Int32GetDatum(varRelid)));
+			list_free(args);
 
 			if (useOr)
 			{
